// 015 u_c_file_of
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_file_of;
  interface
    uses u_c_basic_file;

    type c_file_of= class(c_basic_file)
                      public
                        m_pt_record: Pointer;
                        m_record_size: Integer;
                        // -- not updated here: (should be done for all openings,
                        //--    reading, writing, seeking
                        m_current_position: Integer;

                        Constructor create_file_of(p_name, p_file_name: String;
                            p_pt_record: Pointer; p_record_size: Integer); Virtual;

                        function f_file_size: Integer; Override;
                        function f_file_position: Integer; Override;
                        procedure seek_file(p_position: Integer); Override;
                        function f_seek_end_of_file: Integer; Override;

                        procedure write_record;
                        procedure read_record;

                        function f_display_record: String; Virtual;
                        function f_list: Boolean;

                        Destructor Destroy; Override;
                      end;

  implementation
    uses SysUtils, Windows, u_c_display;

    // -- c_file_of

    Constructor c_file_of.create_file_of(p_name, p_file_name: String;
        p_pt_record: Pointer; p_record_size: Integer);
      begin
        Inherited create_basic_file(p_name, p_file_name);
        m_pt_record:= p_pt_record;
        m_record_size:= p_record_size;
      end; // create_file_of

    // -- file creation, opening, closing

    function c_file_of.f_file_size: Integer;
      begin
        Result:= Inherited f_file_size div m_record_size;
      end; // f_file_size

    function c_file_of.f_file_position: Integer;
      begin
        Result:= Inherited f_file_position div m_record_size;
      end; // f_file_position

    procedure c_file_of.seek_file(p_position: Integer);
      begin
        Inherited seek_file(p_position* m_record_size);
      end; // seek_file

    function c_file_of.f_seek_end_of_file: Integer;
      begin
        // -- go there
        Result:= Inherited f_seek_end_of_file;
        // -- return the RECORD count
        Result:= Result div m_record_size;
      end; // f_seek_end_of_file

    procedure c_file_of.write_record;
      begin
        f_block_write(m_pt_record, m_record_size);
      end; // write_record

    procedure c_file_of.read_record;
      begin
        f_block_read(m_pt_record, m_record_size);
      end; // read_record

    function c_file_of.f_display_record: String;
      begin
        Result:= '';
      end; // f_display_record

    function c_file_of.f_list: Boolean;
      begin
        Result:= False;
        if f_open
          then begin
              while not f_eof do
              begin
                read_record;
                display(f_display_record);
              end;
              close_file;
              Result:= True;
            end
          else begin
              display_bug('could not open');
            end;
      end; // f_list

    Destructor c_file_of.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_file_of
    end. // u_c_file_of
e_of
