// 004 u_ip_packet
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_ip_packet;
  interface
    uses u_sniffer_utils
      ;

    type t_ip_packet= packed record  // 20 bytes+ data
                               m_version_and_header_length: Byte;
                               m_type_of_service: Byte;
                               m_packet_length: Word;

                               // -- identification of a datagram
                               m_datagram_identification: Word;
                               m_flag_and_offset: Word;

                               m_time_to_live: Byte;
                               m_ip_protocol: Byte;
                               m_check_sum: Word;
                               m_ip_source: t_IP_address;
                               m_ip_destination: t_IP_address;

                               // -- variable size
                               m_ip_data: array[0..0] of Byte;
                             end;
         t_pt_ip_packet= ^t_ip_packet;

    const // -- 20 bytes (ethernet+ ip= 34)
          k_ip_header_size= SizeOf(t_ip_packet)- 1;

    // -- the IP sub-protocols

    type t_ip_protocol_info= record
                               m_protocol: Byte;
                               m_name: array [0..19] of Char;
                               m_description: String;
                             end;

    const k_ip_protocol_info: array [0..20] of t_ip_protocol_info=
            (
              (m_protocol: 1;     m_name: 'ICMP';      m_description: 'Internet Control Message'),
              (m_protocol: 2;     m_name: 'IGMP';      m_description: 'Internet Group Management'),
              (m_protocol: 3;     m_name: 'GGP';       m_description: 'Gateway-to-Gateway'),
              (m_protocol: 4;     m_name: 'IP' ;       m_description: 'IP in IP (encasulation)'),
              (m_protocol: 5;     m_name: 'ST' ;       m_description: 'Stream'),
              (m_protocol: 6;     m_name: 'TCP';       m_description: 'Transmission Control'),
              (m_protocol: 8;     m_name: 'EGP';       m_description: 'Exterior Gateway Protocol'),
              (m_protocol: 9;     m_name: 'IGP';       m_description: 'any private interior gateway'),
              (m_protocol: 17;    m_name: 'UDP';       m_description: 'User Datagram'),
              (m_protocol: 27;    m_name: 'RDP';       m_description: 'Reliable Data Protocol'),
              (m_protocol: 28;    m_name: 'IRTP';      m_description: 'Internet Reliable Transaction'),
              (m_protocol: 29;    m_name: 'ISO-TP4';   m_description: 'ISO Transport Protocol Class 4'),
              (m_protocol: 35;    m_name: 'IDPR'   ;   m_description: 'Inter-Domain Policy Routing Protocol'),
              (m_protocol: 37;    m_name: 'DDP'    ;   m_description: 'Datagram Delivery Protocol'),
              (m_protocol: 38;    m_name: 'IDPR-CMTP'; m_description: 'IDPR Control Message Transport Proto'),
              (m_protocol: 88;    m_name: 'IGRP'    ;  m_description: 'IGRP'),
              (m_protocol: 89;    m_name: 'OSPFIGP' ;  m_description: 'OSPFIGP'),
              (m_protocol: 92;    m_name: 'MTP'     ;  m_description: 'Multicast Transport Protocol'),
              (m_protocol: 94;    m_name: 'IPIP'    ;  m_description: 'IP-within-IP Encapsulation Protocol'),
              (m_protocol: 97;    m_name: 'ETHERIP' ;  m_description: 'Ethernet-within-IP Encapsulation'),
              (m_protocol: 98;    m_name: 'ENCAP'   ;  m_description: 'Encapsulation Header')
            );

          k_ip_icmp= 1;
          k_ip_igmp= 2;
          k_ip_tcp= 6;
          k_ip_igp= 9;
          k_ip_udp= 17;

  implementation
  
    begin // u_c_ip_packet
    end. // u_c_ip_packet






