// 010 u_sniff_bde_select
// 04 feb 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_sniff_bde_select;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Db, DBTables, Grids, DBGrids, ComCtrls
  ;

type
  TForm1 = class(TForm)
    Panel4: TPanel;
    Memo1: TMemo;
    DBGrid1: TDBGrid;
    select_: TButton;
    connect_: TButton;
    Database1: TDatabase;
    Query1: TQuery;
    DataSource1: TDataSource;
    exit_: TButton;
    sniff_: TCheckBox;
    sniff_panel: TPanel;
    log_: TCheckBox;
    disconnect_: TButton;
    Panel1: TPanel;
    display_: TButton;
    go_: TButton;
    stats_: TCheckBox;
    list_: TCheckBox;
    display_and_count_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure select_Click(Sender: TObject);
    procedure connect_Click(Sender: TObject);
    procedure display_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure disconnect_Click(Sender: TObject);
    procedure go_Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure display_and_count_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_dates, u_dir, u_exe
      , u_c_log, u_c_display
      , u_c_display_packets
      
    ;

    {$R *.DFM}

     
    (*$i ..\units\i_pathes.pas *)

    // const k_select_sql= 'SELECT * FROM formations';

    var g_c_display_packets: c_display_packets= Nil;

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure trace_display(p_text: String);
      var l_text: String;
      begin
        if g_c_display_packets<> Nil
          then begin
              l_text:= p_text;
              Insert(Format('%5d ', [g_c_display_packets.m_packet_number]),
                  l_text, 3);
              display(l_text+ ' '+ IntToStr(g_c_display_packets.m_packet_number)
                  + ' '+ g_c_display_packets.m_c_timer_now.f_display_delta);
            end
          else display(p_text);
      end; // trace_display

    procedure TForm1.connect_Click(Sender: TObject);
      var l_log_name: String;
      begin
        trace_display('> connect');

        if sniff_.Checked
          then begin
              g_c_display_packets:= c_display_packets.create_display_packets('display_packets',
                  sniff_panel);
      (*
              if log_.Checked
                then g_sniffer_name:= f_now_to_string+ '.bin'
                else g_sniffer_name:= k_no_log_file;
      *)
              if log_.Checked
                then begin
                    f_create_path(k_local_log_path);
                    display(f_exe_path);
                    l_log_name:= k_local_log_path+ f_now_to_string+ '_log_bde.bin'
                  end
                else l_log_name:= '';
              g_c_display_packets.start_capture(0, stats_.Checked, l_log_name, list_.Checked);
            end;

        Database1.Connected:= False;
        Database1.Params.Values['SERVER NAME']:= k_bde_database_path_and_name;
        display(Database1.Params.Values['SERVER NAME']);

        database1.Connected:= True;
        trace_display('< connect');
      end; // connect_Click

    procedure TForm1.select_Click(Sender: TObject);
      var l_count: Integer;
      begin
        trace_display('> select_Click');

        DataSource1.DataSet:= Nil;

        with Query1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add(k_sql_select);
            display_strings(Sql);
            display('> open');
            Open;
            l_count:= 0;
            while not eof do
            begin
              Inc(l_count);
              Application.ProcessMessages;
              Next;
            end; // while not eof
            display('< open');
          end; // with Sql
        end; // with Query1

        trace_display('< select_Click cnt='+ IntToStr(l_count));
      end; // select_Click

    procedure TForm1.display_Click(Sender: TObject);
      begin
        display('> select_Click');

        DataSource1.DataSet:= Query1;

        with Query1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add('Select * from '+ k_table_name);
            display_strings(Sql);
            display('> open');
            Open;
            display('< open');
          end; // with Sql
        end; // with Query1

        display('< select_Click');
      end; // display_Click

    procedure TForm1.display_and_count_Click(Sender: TObject);
      var l_count: Integer;
      begin
        trace_display('> select_Click');

        DataSource1.DataSet:= Query1;

        with Query1 do
        begin
          Close;

          with Sql do
          begin
            Clear;
            Add(k_sql_select);
            display_strings(Sql);
            display('> open');
            Open;
            l_count:= 0;
            while not eof do
            begin
              Inc(l_count);
              Application.ProcessMessages;
              Next;
            end; // while not eof
            display('< open');
          end; // with Sql
        end; // with Query1

        trace_display('< select_Click cnt='+ IntToStr(l_count));
      end; // display_and_count_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.disconnect_Click(Sender: TObject);
      begin
        trace_display('> disconnect_Click');
        Database1.Connected:= False;
        trace_display('< disconnect_Click');
      end; // disconnect_Click

    procedure TForm1.go_Click(Sender: TObject);
      begin
        connect_Click(Nil);
        select_Click(Nil);
        disconnect_Click(Nil);
      end; // go_Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        disconnect_Click(Nil);
      end; // FormClose

end.





